Index: GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshView.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshView.cpp	(revision 1090)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/src/GeoMeshView.cpp	(revision 1526)
@@ -594,13 +594,10 @@
 	//	For each strip.
 //	MultiIndexData *dataInterface = lodStripsLib->dataRetrievalInterface;
-	IndexData *dataInterface = lodStripsLib->dataRetrievalInterface;
+/*	IndexData *dataInterface = lodStripsLib->dataRetrievalInterface;
 	size_t triangle_count = dataInterface->GetNumValidIndices() - 2;
-/*	for (int strip	=	0; strip < dataInterface->GetNumPrims(); strip++)
-	{
-//		triangle_count	+=	lodStripsLib->mStrips[strip].size() - 2;
-		triangle_count	+=	dataInterface->GetNumValidIndices(strip) - 2;
-	}*/
-
-	return	triangle_count;
+
+	return	triangle_count;*/
+
+	return lodStripsLib->GetCurrentTriangleCount();
 }
 
@@ -716,5 +713,5 @@
 		i	= 0;
 
-/*		if (getColorStrips())
+		if (getColorStrips())
 		{
 			//	Gets the color of the strip.
@@ -728,5 +725,7 @@
 			//	Paint a new color.
 			glColor3f(r,g,b);
-		}*/
+			GLfloat color[]	=	{r,g,b,1.0f};
+			glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,color);
+		}
 
 
@@ -904,74 +903,13 @@
 
 		//	For each one of the strips.
-/*		for (int strip = 0; strip < geosubmesh->mStripCount; strip++)
-		{
-			//	Paint the current strip.
-			glBegin(GL_TRIANGLE_STRIP);
-
-			if (getColorStrips())
-			{
-				//	Gets the color of the strip.
-				r	=	mStripColors[submesh][color_index].r;
-				g	=	mStripColors[submesh][color_index].g;
-				b	=	mStripColors[submesh][color_index].b;
-
-				//	Change to the next color.
-				color_index++;
-
-				//	Paint a new color.
-				glColor3f(r,g,b);
-			}
-
-			//	For each index of the strip.
-			for (int index = 0; index < lodStripsLib->dataRetrievalInterface->GetNumValidIndices(current_strip); index++)
-			{
-				position	=	lodStripsLib->dataRetrievalInterface->GetIndex(current_strip,index);
-
-				//	Gets the vertex normal.
-				vector3	=	geosubmesh->mVertexBuffer->mNormal[position];
-
-				x				=	vector3[0];
-				y				=	vector3[1];
-				z				=	vector3[2];
-
-				//	Sets the vertex normal.
-				glNormal3f(x,y,z);
-
-				// set the texture coordinates if needed
-				if (usetex)
-				{
-					vector2 = geosubmesh->mVertexBuffer->mTexCoords[position];
-					x				=	vector2[0];
-					y				=	vector2[1];
-					glTexCoord2f(x,y);
-				}
-
-				//	Gets the vertex coordinates.
-				vector3	=	geosubmesh->mVertexBuffer->mPosition[position];
-
-				x				=	vector3[0];
-				y				=	vector3[1];
-				z				=	vector3[2];
-
-				//	Sets the vertex position.
-				glVertex3f(x,y,z);
-			}
-
-			//	Increments current strip.
-			current_strip++;
-
-			//	A strip is generated.
-			glEnd();
-
-		}*/
-
 		int indices_to_render = lodStripsLib->GetValidIndexCount(submesh);
 		int offset = lodStripsLib->GetValidOffset(submesh);
 
 		glBegin(GL_TRIANGLE_STRIP);
-		//for (int index = 0; index < lodStripsLib->dataRetrievalInterface->GetNumValidIndices(); index ++)
-		for (int index = offset; index < indices_to_render+offset; index ++)
-		{
-			position = lodStripsLib->dataRetrievalInterface->GetIndex(index);
+//		for (int index = offset; index < indices_to_render+offset; index ++)
+		for (int index = 0; index < mGeoMeshViewUI->lod_index_data->indexCount[submesh]; index ++)
+		{
+//			position = lodStripsLib->dataRetrievalInterface->GetIndex(index);
+			position = mGeoMeshViewUI->lod_index_data->indices[submesh][index];
 
 			//	Gets the vertex normal.
@@ -1045,74 +983,13 @@
 
 		//	For each one of the strips.
-/*		for (int strip = 0; strip < geosubmesh->mStripCount; strip++)
-		{
-			//	Paint the current strip.
-			glBegin(GL_TRIANGLE_STRIP);
-
-			if (getColorStrips())
-			{
-				//	Gets the color of the strip.
-				r	=	mStripColors[submesh][color_index].r;
-				g	=	mStripColors[submesh][color_index].g;
-				b	=	mStripColors[submesh][color_index].b;
-
-				//	Change to the next color.
-				color_index++;
-
-				//	Paint a new color.
-				glColor3f(r,g,b);
-			}
-
-			//	For each index of the strip.
-			for (int index = 0; index < lodTreeLib->CurrentLOD_Trunk_IndexCountByStrip(current_strip); index++)
-			{
-				position = lodTreeLib->CurrentLOD_Trunk_Indices()->GetIndex(current_strip,index);
-
-				//	Gets the vertex normal.
-				vector3	=	geosubmesh->mVertexBuffer->mNormal[position];
-
-				x				=	vector3[0];
-				y				=	vector3[1];
-				z				=	vector3[2];
-
-				//	Sets the vertex normal.
-				glNormal3f(x,y,z);
-
-				// set the texture coordinates if needed
-				if (usetex)
-				{
-					vector2 = geosubmesh->mVertexBuffer->mTexCoords[position];
-					x				=	vector2[0];
-					y				=	vector2[1];
-					glTexCoord2f(x,y);
-				}
-
-				//	Gets the vertex coordinates.
-				vector3	=	geosubmesh->mVertexBuffer->mPosition[position];
-
-				x				=	vector3[0];
-				y				=	vector3[1];
-				z				=	vector3[2];
-
-				//	Sets the vertex position.
-				glVertex3f(x,y,z);
-			}
-
-			//	Increments current strip.
-			current_strip++;
-
-			//	A strip is generated.
-			glEnd();
-
-		}*/
-	
-//		int indices_to_render = lodTreeLib->trunk->GetValidIndexCount(submesh);
 		int indices_to_render = lodTreeLib->GetValidTrunkIndexCount(submesh);
 		int begin_index = lodTreeLib->GetValidTrunkOffset(submesh);
         		
 		glBegin(GL_TRIANGLE_STRIP);
-		for (int index = begin_index; index < indices_to_render+begin_index; index ++)
-		{
-			position = lodTreeLib->CurrentLOD_Trunk_Indices()->GetIndex(index);
+//		for (int index = begin_index; index < indices_to_render+begin_index; index ++)
+		for (int index = 0; index < mGeoMeshViewUI->lod_index_data->indexCount[submesh]; index ++)
+		{
+//			position = lodTreeLib->CurrentLOD_Trunk_Indices()->GetIndex(index);
+			position = mGeoMeshViewUI->lod_index_data->indices[submesh][index];
 
 			//	Gets the vertex normal.
@@ -1157,18 +1034,18 @@
 
 	glBegin(GL_TRIANGLES);
-	const Geometry::VertexData *foliage_verts = lodTreeLib->Get_Foliage_VertexData();
-	const Geometry::IndexData *foliage_inds = lodTreeLib->CurrentLOD_Foliage_Indices();
-	for (int j=0; j<lodTreeLib->CurrentLOD_Foliage_IndexCount(); j++)
-	{
-		float vx,vy,vz;
+	Geometry::SubMesh & foliageSubMesh = geoMesh->mSubMesh[lodTreeLib->GetLeavesSubMesh()];
+	Geometry::Vector3 auxv;
+	for (int j=0; j<mGeoMeshViewUI->lod_index_data->indexCount[lodTreeLib->GetLeavesSubMesh()]; j++)
+	{		
+		int k = mGeoMeshViewUI->lod_index_data->indices[lodTreeLib->GetLeavesSubMesh()][j];
 		if (usetex)
 		{
-			foliage_verts->GetVertexTexCoord(foliage_inds->GetIndex(j),vx,vy);
-			glTexCoord2f(vx,vy);
-		}
-		foliage_verts->GetVertexNormal(foliage_inds->GetIndex(j),vx,vy,vz);
-		glNormal3f(vx,vy,vz);
-		foliage_verts->GetVertexCoord(foliage_inds->GetIndex(j),vx,vy,vz);
-		glVertex3f(vx,vy,vz);
+			Geometry::Vector2 tc = foliageSubMesh.mVertexBuffer->mTexCoords[k];
+			glTexCoord2f(tc.x,tc.y);
+		}
+		auxv = foliageSubMesh.mVertexBuffer->mNormal[k];
+		glNormal3f(auxv.x,auxv.y,auxv.z);
+		auxv = foliageSubMesh.mVertexBuffer->mPosition[k];
+		glVertex3f(auxv.x,auxv.y,auxv.z);
 	}
 	glEnd();
@@ -1253,5 +1130,5 @@
 
 	glEnable (GL_POLYGON_OFFSET_LINE);
-	glPolygonOffset(-1,-1);
+	glPolygonOffset(-0.5,1);
 	glEnable(GL_DEPTH_TEST);
 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
@@ -1269,5 +1146,5 @@
 	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,color_blanco);
 
-	glClearColor(0,0,0,0);
+	glClearColor(0.3,0.3,0.3,0);
 	
 	if (mCW)
@@ -1292,5 +1169,5 @@
 	{
 		enableColorStrips();
-		glDisable(GL_LIGHTING);
+		//glDisable(GL_LIGHTING);
 		glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
 		drawGeoMesh(false);
@@ -1304,6 +1181,9 @@
 	{
 		disableColorStrips();
-		glDisable(GL_LIGHTING);
-		glColor3d(0.0, 0.0, 1.0);
+		//glDisable(GL_LIGHTING);
+		glColor3d(0.0, 0.0, 0.0);
+		GLfloat color[]	=	{0.0f,0.0f,0.0f,1.0f};
+		glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,color);
+
 		glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
 		drawGeoMesh(true);
@@ -1313,6 +1193,6 @@
 		if (!mSolid)
 		{
-			enableColorStrips();
-			glEnable(GL_LIGHTING);
+			disableColorStrips();
+			//glEnable(GL_LIGHTING);
 			glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
 			drawGeoMesh(false);
